#ifndef lint
static char *rcsid = "$Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/query_engine/RCS/util.c,v 0.95 91/09/02 11:35:19 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/query_engine/RCS/util.c,v 0.95 91/09/02 11:35:19 emsrdsm Exp Locker: emsrdsm $ */

/*
 * $Log:	util.c,v $
 * Revision 0.95  91/09/02  11:35:19  emsrdsm
 * *** empty log message ***
 * 
 * Revision 0.91  91/02/18  11:48:08  emsrdsm
 * *** empty log message ***
 * 
 * Revision 0.9  91/02/18  11:42:28  emsrdsm
 * *** empty log message ***
 * 
 * Revision 0.8  91/02/18  11:33:43  emsrdsm
 * *** empty log message ***
 * 
 *
 *
 */

#include "types.h"
#include "util.h"
#include "quipu/util.h"

char *copy_string(string)
     char *string;
{
  char *new_string;

  if (string == NULLCP) return NULLCP;

  new_string = (char *) smalloc(strlen(string) + 1);
  (void) strcpy(new_string, string);

  return new_string;
}

void friendlify(name, fname)
     char *name, *fname;
{
  register char *start, *end, *endval;
  char *startval;
  char save;
  static char valbuf[LINESIZE];

  *fname = '\0';

  if (name == NULLCP || isnull(*name))
    return;

  end = name;

  while (!isnull(*end))
    end++;

  while (end > name && isspace(*(end - 1)))
    end--;
  
  while (1)
    {
      start = end - 1;

      /*
       * Get to beginning of RDN
       */

      while (*start != '@' && *start != '\n' && start > name)
	start--;

      if (start != name)
	start++;
      

      /*
       * Start now points to RDN as string
       */

      save = *end;
      *end = '\0';


      /*
       * Skip space
       */

      while (isspace(*start))
	start++;

      /* 
       * Get values from RDN --> valbuf
       */

      valbuf[0] = '\0';
      endval = 0;
      startval = start;

      while (endval < end)
	{
	  while (*start != '=')
	    start++;
	  
	  while (!isalpha(*start) && !isalnum(*start))
	    start++;
	  
	  for (endval = start; endval < end && *endval != '%'; endval++)
	    ;
	  
	  if (*endval == '%')
	    *endval = '\0';
	  
	  if (valbuf[0] != '\0')
	    (void) strcat(valbuf, " + ");

	  (void) strcat(valbuf, start);

	  if (endval != end)
	    *endval = '%';

	  start = endval;
	}
      
      start = startval;

      /*
       * Append the value to output 
       */

      if (!isnull(*fname))
	(void) strcat(fname, ", ");

      (void) strcat(fname, valbuf);


      *end = save;

      if (start == name)
	break;

      end = start - 1;

      while (*end != '\n' && *end != '@' && isspace(*end))
	end--;
    }
}

