#ifndef _xdir_requests_h_
#define _xdir_requests_h_

#include "windows.h"
#include "actions.h"
#include "query.h"

typedef struct _assoc_rec
{
  QCardinal request_id;
  request_type type;

  XtInputId input_id;
  int assoc_desc;

  Widget this_widget;
  Cardinal object_id;
  Cardinal prim_id;

  actionID action_id;
  translationList trans_list;

  struct _assoc_rec *next;
} assoc_rec, *assocRec;

#define assoc_rec_alloc() (assocRec) XtMalloc(sizeof(assoc_rec))
#define NULLAssocRec (assocRec) NULL

void request_invoked();
void request_complete();

#endif
