/*****************************************************************************

  widgets.h - Declarations for widget/part  creation functions.

*****************************************************************************/

#ifndef _Xdir_widgets_h
#define _Xdir_widgets_h

#include "windows.h"
#include "defs.h"
#include "actions.h"

typedef struct _prim_info
{
  Cardinal primitive_id;
  Cardinal object_id;
  actionID action_id;
} prim_info, *primInfo;

#define NULLPrimInfo (primInfo) NULL
#define prim_info_alloc() (primInfo) XtMalloc(sizeof(prim_info))

Widget makeStatusLabel(), makeTitleBar(), makeReadDisplay(),
       makeSearchGroup(), makeListDisplay(), makeHelpDisplay(),
       makeModifyWindow(), makeButton(), makeMoveto(), makeErrorViewer();

void init_actions(), init_widgets();

#endif _Xdir_widgets_h


