#ifndef lint
static char *rcsid = "$Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/xdutil.c,v 0.95 91/09/02 11:37:48 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/xdutil.c,v 0.95 91/09/02 11:37:48 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  xdutil.c - Assorted procedures

*****************************************************************************/

#include "xdutil.h"
#include "defs.h"
#include "quipu/attr.h"
#include "configure.h"


attributeName attr_name_list = NULLAttributeName;

void exit();

/*
 * - getAttributeName() -
 *
 * Find user defined name for an attribute, or else return name defined
 * in oidtables
 *
 */
String getAttributeName(attr_type)
     AttributeType attr_type;
{
  register attributeName names;
  
  for (names = attr_name_list;
       names != NULLAttributeName && names->type != attr_type;
       names = names->next)
    ;

  if (names != NULLAttributeName && names->name != NULLString)
    return names->name;

  return attr2name(attr_type, OIDPART);
}

/*
 * - getAttributeOfName() -
 *
 *
 */
AttributeType getAttributeOfName(name)
     String name;
{
  register attributeName names;
  
  for (names = attr_name_list;
       names != NULLAttributeName && lexequ(names->name, name) != 0;
       names = names->next)
    ;

  if (names != NULLAttributeName && names->name != NULLString)
    return names->type;

  return AttrT_new(name);
} /* getAttributeOfName */


void xluWarning(msg)
     String msg;
{
  char err_msg[LINESIZE];

  (void) sprintf(err_msg, "Error : %s\n", msg);
  (void) fprintf(stderr, "%s", err_msg);
}

void xluFatal(error)
     String error;
{
  char err_msg[LINESIZE];

  (void) sprintf(err_msg, "Fatal error : %s\n", error);
  (void) fprintf(stderr, "%s", err_msg);

  exit(1);
}

