#ifndef lint
static char *rcsid = "$Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/query_user.c,v 0.95 91/09/02 11:37:18 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/query_user.c,v 0.95 91/09/02 11:37:18 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  query_user.c - Post a query window

*****************************************************************************/

#include "types.h"
#include "windows.h"
#include "objects.h"

#include <X11/StringDefs.h>
#include <X11/cursorfont.h>
#include <X11/Xutil.h>
#include <X11/Shell.h>

#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>


extern Widget toplevel;
extern XtTranslations pel_trans_table;

extern windowObject win_objects[];

void postQueryMessage(parent_id, 
		      message,
		      want_cancel,
		      call_on_ok,
		      call_on_cancel,
		      data)
     Cardinal parent_id;
     String message;
     QBool want_cancel;
     XtCallbackProc call_on_ok, call_on_cancel;
     XtPointer data;
{
  windowObject this_object = win_objects[parent_id];
  Widget parent_shell, label, popup_shell, form, ok_button, cancel_button;
  Arg args[MAXARGS];
  Cardinal count;
  Position x, y;

  parent_shell = this_object->parent_shell;
  XtTranslateCoords(parent_shell, -20, 20, &x, &y);

  if (x < 0)
    x = 0;

  XBell(XtDisplay(parent_shell), 40);

  popup_shell = XtCreatePopupShell("Query",
				   transientShellWidgetClass,
				   toplevel,
				   args,
				   0);

  count = 0;

  XtSetArg(args[count], XtNdefaultDistance, 16); count++;

  form = XtCreateManagedWidget("messageForm",
			       formWidgetClass,
			       popup_shell,
			       args,
			       0);

  
  count = 0;
  
  XtSetArg(args[count], XtNlabel, message); count++;
  XtSetArg(args[count], XtNborderWidth, 0); count++;

  label = XtCreateManagedWidget("queryLabel",
				labelWidgetClass,
				form,
				args,
				count);

  
  count = 0;
  
  XtSetArg(args[count], XtNfromVert, label); count++;
  
  ok_button = XtCreateManagedWidget("messageOkButton",
				    commandWidgetClass,
				    form,
				    args,
				    count);

  XtAddCallback(ok_button, XtNcallback, call_on_ok, data);

  XtOverrideTranslations(ok_button, pel_trans_table);

  if (want_cancel == TRUE)
    {
      count = 0;
      
      XtSetArg(args[count], XtNfromVert, label); count++;
      XtSetArg(args[count], XtNfromHoriz, ok_button); count++;
  
      cancel_button = XtCreateManagedWidget("messageCancelButton",
					    commandWidgetClass,
					    form,
					    args,
					    count);

      XtAddCallback(cancel_button, XtNcallback, call_on_cancel, data);

      XtOverrideTranslations(cancel_button, pel_trans_table);
    }
  
  XtMoveWidget(popup_shell, x, y);

  XtPopup(popup_shell, XtGrabExclusive);
} /* postUserQuery */


void deleteQueryMessage(w)
     Widget w;
{
  Widget shell;

  for (shell = w;
       shell != NULLWidget && XtClass(shell) != transientShellWidgetClass;
       shell = XtParent(shell))
    ;

  if (shell != NULLWidget)
    XtDestroyWidget(shell);
}
